=== SConstruct ===
#J vim:syntax=python
print '''
      C S O U N D 5

SCons build file for Csound 5:
API library, plugin opcodes, utilities, and front ends.

By Michael Gogins <gogins at pipeline dot com>

For custom options, run 'scons -h'.
For default options, run 'scons -H'.
If headers or libraries are not found, edit 'custom.py'.
For Linux, run in the standard shell
    with standard Python and just run 'scons'.
For MinGW, run in the MSys shell
    and use www.python.org WIN32 Python to run scons.
For Microsoft Visual C++, run in the Platform SDK
    command shell, and use www.python.org WIN32 Python to run scons.
'''

import time
import glob
import os
import os.path
import sys
import string
import shutil
import copy

#############################################################################
#
#   UTILITY FUNCTIONS
#
#############################################################################

pluginLibraries = []
executables = []
headers = Split('''
    H/cfgvar.h H/cscore.h H/csdl.h H/csound.h H/csound.hpp H/csoundCore.h
    H/cwindow.h H/msg_attr.h H/OpcodeBase.hpp H/pstream.h H/pvfileio.h
    H/soundio.h H/sysdep.h H/text.h H/version.h H/float-version.h
    interfaces/CsoundFile.hpp interfaces/CppSound.hpp interfaces/filebuilding.h
''')
libs = []
pythonModules = []

def today():
    return time.strftime("%Y-%m-%d", time.localtime())

# Detect OPERATING SYSTEM platform.

def getPlatform():
    if sys.platform[:5] == 'linux':
        return 'linux'
    elif sys.platform[:3] == 'win':
        return 'win32'
    elif sys.platform[:6] == 'darwin':
        return 'darwin'
    elif sys.platform[:5] == 'sunos':
        return 'sunos'
    else:
        return 'unsupported'

#############################################################################
#
#   DEFINE CONFIGURATION
#
#############################################################################

print "System platform is '" + getPlatform() + "'."


# Create options that can be set from the command line.

commandOptions = Variables() # was Options()
commandOptions.Add('CC')
commandOptions.Add('CXX')
commandOptions.Add('LINK')
commandOptions.Add('LINKFLAGS')
commandOptions.Add('custom',
    'Specify name of custom options file (default is "custom.py")',
    'custom.py')
commandOptions.Add('useDouble',
    'Set to 1 to use double-precision floating point for audio samples.',
    '0')
commandOptions.Add('usePortAudio',
    'Set to 1 to use PortAudio for real-time audio input and output.',
    '1')
commandOptions.Add('usePortMIDI',
    'Build PortMidi plugin for real time MIDI input and output.',
    '1')
commandOptions.Add('useALSA',
    'Set to 1 to use ALSA for real-time audio and MIDI input and output.',
    '1')
commandOptions.Add('useJack',
    'Set to 1 if you compiled PortAudio to use Jack; also builds Jack plugin.',
    '1')
commandOptions.Add('useFLTK',
    'Set to 1 to use FLTK for graphs and widget opcodes.',
    '1')
commandOptions.Add('noFLTKThreads',
    'Set to 1 to disable use of a separate thread for FLTK widgets.',
    '1')
commandOptions.Add('pythonVersion',
    'Set to the Python version to be used.',
    '%d.%d' % (int(sys.hexversion) >> 24, (int(sys.hexversion) >> 16) & 255))
commandOptions.Add('buildCsoundVST',
    'Set to 1 to build CsoundVST (needs CsoundAC, FLTK, boost, Python, SWIG).',
    '0')
commandOptions.Add('buildCsoundAC',
    'Set to 1 to build CsoundAC (needs Eigen 3, FLTK, boost, Python, SWIG).',
    '0')
commandOptions.Add('buildCsound5GUI',
    'Build FLTK GUI frontend (requires FLTK 1.1.7 or later).',
    '0')
commandOptions.Add('generateTags',
    'Set to 1 to generate TAGS',
    '0')
commandOptions.Add('generatePdf',
    'Set to 1 to generate PDF documentation',
    '0')
#commandOptions.Add('buildLoris',
#    'Set to 1 to build the Loris Python extension and opcodes',
#    '1')
commandOptions.Add('useOSC',
    'Set to 1 if you want OSC support',
    '0')
commandOptions.Add('bufferoverflowu',
    'Set to 1 to use the Windows buffer overflow library, required if you use MinGW to link with MSVC-built libraries',
    '0')
if getPlatform() != 'win32':
    commandOptions.Add('useUDP',
        'Set to 0 if you do not want UDP support',
        '1')
else:
    commandOptions.Add('useUDP',
        'Set to 1 if you want UDP support',
        '0')
commandOptions.Add('buildPythonOpcodes',
    'Set to 1 to build Python opcodes',
    '0')
commandOptions.Add('buildLuaOpcodes',
    'Set to 1 to build Lua opcodes',
    '0')
commandOptions.Add('prefix',
    'Base directory for installs. Defaults to /usr/local.',
    '/usr/local')
commandOptions.Add('instdir',
    'For the install target: puts instdir before the prefix',
    '')
commandOptions.Add('buildRelease',
    'Set to 1 to build for release (implies noDebug).',
    '0')
commandOptions.Add('noDebug',
    'Build without debugging information.',
    '0')
commandOptions.Add('gcc3opt',
    'Enable gcc 3.3.x or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
commandOptions.Add('gcc4opt',
    'Enable gcc 4.0 or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
commandOptions.Add('useLrint',
    'Use lrint() and lrintf() for converting floating point values to integers.',
    '0')
commandOptions.Add('useGprof',
    'Build with profiling information (-pg).',
    '0')
commandOptions.Add('Word64',
    'Build for 64bit computer',
    '0')
commandOptions.Add('Lib64',
    'Build for lib64 rather than lib',
    '0')
if getPlatform() == 'win32':
    commandOptions.Add('dynamicCsoundLibrary',
        'Set to 0 to build static Csound library instead of csound.dll',
        '1')
else:
    commandOptions.Add('dynamicCsoundLibrary',
        'Build dynamic Csound library instead of libcsound.a',
        '0')
commandOptions.Add('buildStkOpcodes',
    "Build opcodes encapsulating Perry Cook's Synthesis Toolkit in C++ instruments and effects",
    '0')
commandOptions.Add('install',
    'Enables the Install targets',
    '0')
commandOptions.Add('buildPDClass',
    "build csoundapi~ PD class (needs m_pd.h in the standard places)",
    '0')
commandOptions.Add('useCoreAudio',
    "Set to 1 to use CoreAudio for real-time audio input and output.",
    '1')
commandOptions.Add('useAltivec',
    "On OSX use the gcc AltiVec optmisation flags",
    '0')
commandOptions.Add('buildDSSI',
    "Build DSSI/LADSPA host opcodes",
    '1')
commandOptions.Add('buildUtilities',
    "Build stand-alone executables for utilities that can also be used with -U",
    '1')
commandOptions.Add('buildTclcsound',
    "Build Tclcsound frontend (cstclsh, cswish and tclcsound dynamic module). Requires Tcl/Tk headers and libs",
    '0')
commandOptions.Add('buildWinsound',
    "Build Winsound frontend. Requires FLTK headers and libs",
    '0')
commandOptions.Add('buildVirtual',
    "Build Virtual MIDI keyboard. Requires FLTK 1.1.7 or later headers and libs",
    '0')
commandOptions.Add('buildInterfaces',
    "Build C++ interface library.",
    '0')
commandOptions.Add('buildLuaWrapper',
    'Set to 1 to build Lua wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
commandOptions.Add('buildPythonWrapper',
    'Set to 1 to build Python wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
commandOptions.Add('buildJavaWrapper',
    'Set to 1 to build Java wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
#commandOptions.Add('buildOSXGUI',
#    'On OSX, set to 1 to build the basic GUI frontend',
#    '0')
#commandOptions.Add('buildCSEditor',
#    'Set to 1 to build the Csound syntax highlighting text editor. Requires FLTK headers and libs',
#    '0')
commandOptions.Add('withICL',
    'On Windows, set to 1 to build with the Intel C++ Compiler (also requires Microsoft Visual C++), or set to 0 to build with MinGW',
    '0')
commandOptions.Add('withMSVC',
    'On Windows, set to 1 to build with Microsoft Visual C++, or set to 0 to build with MinGW',
    '0')
commandOptions.Add('withSunStudio',
    'On Solaris, set to 1 to build with Sun Studio, or set to 0 to build with gcc',
    '1')
commandOptions.Add('buildNewParser',
    'Enable building new parser (requires Flex/Bison)',
    '1')
commandOptions.Add('NewParserDebug',
    'Enable tracing of new parser',
    '0')
commandOptions.Add('buildMultiCore',
    'Enable building for multicore sytem (requires new parser)',
    '1')
commandOptions.Add('buildvst4cs',
    'Set to 1 to build vst4cs plugins (requires Steinberg VST headers)',
    '0')
if getPlatform() == 'win32':
  commandOptions.Add('useGettext',
    'Set to 1 to use the GBU internationalisation/localisation scheme',
    '0')
else:
  commandOptions.Add('useGettext',
    'Set to 0 for none and 1 for GNU internationalisation/localisation scheme',
    '1')
commandOptions.Add('buildImageOpcodes',
    'Set to 0 to avoid building image opcodes',
    '1')
commandOptions.Add('useOpenMP',
    'Set to 1 to use OpenMP for parallel performance',
    '0')
commandOptions.Add('tclversion',
    'Set to 8.4 or 8.5',
    '8.5')
commandOptions.Add('includeWii',
     'Set to 12 or 13 if using libwiiuse v0.12 or v0.13',
     '0')
commandOptions.Add('includeP5Glove',
     'Set to 1 if using P5 Glove',
     '0')
commandOptions.Add('buildBeats',
     'Set to 1 if building beats score language',
     '1')
commandOptions.Add('buildcatalog',
     'Set to 1 if building opcode/library catalogue',
     '0')
commandOptions.Add('includeSerial',
     'Set to 1 if compiling serial code',
     '1')
# Define the common part of the build environment.
# This section also sets up customized options for third-party libraries, which
# should take priority over default options.

commonEnvironment = Environment(ENV = os.environ)
commandOptions.Update(commonEnvironment)

def compilerIntel():
    if getPlatform() == 'win32' and commonEnvironment['withICL'] == '1':
        return True
    else:
        return False

def compilerMicrosoft():
    if getPlatform() == 'win32' and commonEnvironment['withMSVC'] == '1':
        return True
    else:
        return False

def compilerSun():
    if getPlatform() == 'sunos' and commonEnvironment['withSunStudio'] == '1':
        return True
    else:
        return False

def compilerGNU():
    if not compilerIntel() and not compilerMicrosoft() and not compilerSun():
        return True
    else:
        return False

optionsFilename = 'custom.py'

if compilerIntel():
	Tool('icl')(commonEnvironment)
	optionsFilename = 'custom-msvc.py'
elif compilerMicrosoft():
	optionsFilename = 'custom-msvc.py'
elif getPlatform() == 'win32':
	# On Windows, to exclude MSVC tools,
	# we have to force MinGW tools and then re-create
	# the environment from scratch.
	commonEnvironment = Environment(ENV = os.environ, tools = ['mingw', 'swig', 'javac', 'jar'])
	commandOptions.Update(commonEnvironment)
	#Tool('mingw')(commonEnvironment)
	optionsFilename = 'custom-mingw.py'

if(not FindFile(optionsFilename, '.')):
    print "\n\n*************************************************"  
    print "%s NOT FOUND, please copy one of the custom-***.py" % optionsFilename
    print "as %s and modify it to suit your system, if necessary" % optionsFilename
    print "*************************************************"  
    Exit(-1)


Help(commandOptions.GenerateHelpText(commonEnvironment))

if commonEnvironment['custom']:
    optionsFilename = commonEnvironment['custom']

Requires(optionsFilename, commonEnvironment)
   

print "Using options from '%s.'" % optionsFilename

fileOptions = Options(optionsFilename)
fileOptions.Add('customCPPPATH', 'List of custom CPPPATH variables')
fileOptions.Add('customCCFLAGS')
fileOptions.Add('customCXXFLAGS')
fileOptions.Add('customLIBS')
fileOptions.Add('customLIBPATH')
fileOptions.Add('customSHLINKFLAGS')
fileOptions.Add('customSWIGFLAGS')
fileOptions.Update(commonEnvironment)

customCPPPATH = commonEnvironment['customCPPPATH']
