=== debian/changelog ===
csound (1:5.17.11~dfsg-3) unstable; urgency=low

  * Install missing interlocks.h file

 -- Felipe Sateler <fsateler@debian.org>  Fri, 12 Apr 2013 17:59:48 -0300

csound (1:5.17.11~dfsg-2) unstable; urgency=low

  * Backport fix from upstream to build the java interface correctly

 -- Felipe Sateler <fsateler@debian.org>  Fri, 28 Sep 2012 18:56:24 -0300

csound (1:5.17.11~dfsg-1) unstable; urgency=low

  [ Forrest Cahoon ]
  * Imported Upstream version 5.17.11~dfsg
   - refresh patches for new upstream sources
  * Add patch for CsoundAC CMake bugfix
  * Build with new parser, old one is now unsupported upstream
  * Debian-specific hack for CMake to set an appropriate libsndfile version.
     Closes: #676145

  [ Felipe Sateler ]
  * Add build-dependency on libeigen3-dev, necessary for CsoundAC
  * Add Forrest to Uploaders

 -- Felipe Sateler <fsateler@debian.org>  Sat, 16 Jun 2012 10:01:58 -0400
